#ifndef MOO_DEBUG_H
#define MOO_DEBUG_H

#include <QDebug>

namespace moo {

bool checkDebug(const QString &domain);

class DebugHelper {
    QDebug *stream;

public:
    DebugHelper(const QString &domain) :
        stream(0)
    {
        if (checkDebug(domain))
            stream = new QDebug(QtDebugMsg);
    }

    ~DebugHelper()
    {
        delete stream;
    }

    template<typename T>
    DebugHelper &operator << (const T &arg)
    {
        if (stream)
            *stream << arg;
        return *this;
    }
};

}

inline moo::DebugHelper mDebug(const QString &domain)
{
    return moo::DebugHelper(domain);
}

#endif // MOO_DEBUG_H
