#ifndef MOO_DOC_WINDOW_H
#define MOO_DOC_WINDOW_H

#include <moo/appwindow.h>
#include <moo/pimpl.h>

class QMenu;

namespace moo {

class Document;
class DocumentView;

class DocumentWindowPrivate;
class DocumentWindow : public AppWindow {
    Q_OBJECT
    M_DECLARE_IMPL(DocumentWindow)

    Q_PROPERTY(Document* document READ document)

public:
    virtual Document *document() = 0;

    static void openFile(const QUrl &url, DocumentWindow *window = 0);
    virtual void present(DocumentWindow *old);

protected:
    QMenu *recentMenu();

    DocumentWindow(const QString &name);
    ~DocumentWindow();

    virtual void initUi();

private:
    bool loadFile(const QUrl &url);
    void saveFile(const QUrl &url, const QString &type, bool close_on_save, bool ask_filename = false);
    static void loadFile(const QUrl &url, DocumentWindow *active);

    virtual QList<QUrl> openFileDialog() = 0;
    virtual QUrl saveFileDialog(QString *type) = 0;

    void closeEvent(QCloseEvent *e);

private Q_SLOTS:
    void docStateChanged();

    void actionOpen();
    void actionSave();
    void actionSaveAs();
};

}

#endif // MOO_DOC_WINDOW_H
